package ru.dbotthepony.mc.otm.item

import net.minecraft.ChatFormatting
import net.minecraft.network.chat.Component
import net.minecraft.server.level.ServerPlayer
import net.minecraft.world.InteractionHand
import net.minecraft.world.InteractionResultHolder
import net.minecraft.world.damagesource.DamageSource
import net.minecraft.world.entity.LivingEntity
import net.minecraft.world.entity.player.Player
import net.minecraft.world.item.Item
import net.minecraft.world.item.ItemStack
import net.minecraft.world.item.Rarity
import net.minecraft.world.item.TooltipFlag
import net.minecraft.world.item.UseAnim
import net.minecraft.world.level.Level
import ru.dbotthepony.mc.otm.OverdriveThatMatters
import ru.dbotthepony.mc.otm.ServerConfig
import ru.dbotthepony.mc.otm.capability.matteryPlayer
import ru.dbotthepony.mc.otm.client.minecraft
import ru.dbotthepony.mc.otm.core.TranslatableComponent
import ru.dbotthepony.mc.otm.core.registryName
import ru.dbotthepony.mc.otm.core.toUUID
import ru.dbotthepony.mc.otm.runIfClient
import java.util.UUID

class ExoSuitSlotUpgradeItem : AbstractExoSuitSlotUpgradeItem {
	val hasDescription: Boolean
	val slotCount: Int
	val isCreative: Boolean

	private val uuidProvider: () -> UUID?

	override fun uuid(itemStack: ItemStack): UUID? {
		return uuidProvider.invoke()
	}

	override fun hasDescription(itemStack: ItemStack): Boolean {
		return hasDescription
	}

	override fun slotCount(itemStack: ItemStack): Int {
		return slotCount
	}

	constructor(slotCount: Int, properties: Properties = defaultProperties(), hasDescription: Boolean = false) : super(properties) {
		isCreative = false
		this.slotCount = slotCount
		this.uuidProvider = lazy { registryName!!.toUUID() }::value
		this.hasDescription = hasDescription
	}

	constructor(uuid: UUID?, slotCount: Int, properties: Properties = defaultProperties(), hasDescription: Boolean = false) : super(properties) {
		isCreative = uuid == null
		this.slotCount = slotCount
		this.uuidProvider = { UUID(0L, 0L) }
		this.hasDescription = hasDescription
	}

	constructor(slotCount: Int, rarity: Rarity, hasDescription: Boolean = false) : super(defaultProperties(rarity)) {
		isCreative = false
		this.slotCount = slotCount
		this.uuidProvider = lazy { registryName!!.toUUID() }::value
		this.hasDescription = hasDescription
	}

	constructor(uuid: UUID?, slotCount: Int, rarity: Rarity, hasDescription: Boolean = false) : super(defaultProperties(rarity)) {
		isCreative = uuid == null
		this.slotCount = slotCount
		this.uuidProvider = { UUID(0L, 0L) }
		this.hasDescription = hasDescription
	}
}
